﻿
//Make requested change to JSON data
function change(object,newer,desc) 
{
  /*var older = eval(object);
  
  if(newer.constructor == Object) {
    older = JSON.stringify(older);
    newer = JSON.stringify(newer);
  }*/
  
  recordChange(object,eval(object),newer,desc);
  eval(object+"=newer");
  
  if (/json.students\[[0-9]+\].points\[/.test(object)) {
    var j = object.match(/[0-9]+/)[0]; //student index
    updatePercentageFor(j);
  } else if (/json.assignments\[[0-9]+\].max/.test(object)) {
    updatePercentages();
  }
}

// Record JSON data changes to undo-redo history
function recordChange(object,older,newer,desc)
{
  if (json.history_index > 0) {
    json.history.splice(0,json.history_index);
    json.history_index = 0;
  }
  if (/undo/.test(newer)) newer = newer.split(/,"history":\[.+\],"history_index":[0-9]+/).join("");
  json.history.unshift({undo:object+"='"+escape(older)+"'", redo:object+"='"+escape(newer)+"'"});
  
  if (json.history.length > 20) json.history.pop() //limits undo-redo history to last 20 changes
  
  if (saving) el("save_button").disabled = false;
  el("undo_button").disabled = false;
  el("undo_button").title = "Undo "+desc;
  el("redo_button").disabled = true;
}


function undo()
{
  if (json.history_index < json.history.length) {
    var steps = 1;
    for (var i = 1; i <= steps; i++) {
      var statement = json.history[json.history_index].undo.split("=");
      if (statement[0] == "json.students" || statement[0] == "json.assignments" || statement[0] == "json") {
        eval(statement[0]+"="+eval(unescape(statement[1])));
      } else if (/__m__/.test(statement[0])) { //multiple statements changed at once and recorded in one undo step. Indiv. statements separated by __m__
        statement[0] = statement[0].split("__m__");
        statement[1] = statement[1].split("__m__");
        for (i=0; i < statement[0].length; i++)
          eval(statement[0][i]+"="+eval(unescape(statement[1][i])));
      } else {
        eval(statement[0]+"="+unescape(statement[1]));
      }
      json.history_index += 1;
    }
    importData();
    if (json.history_index >= json.history.length) el("undo_button").disabled = true;
    el("redo_button").disabled = false;
  }
}

function redo(steps)
{
  if (json.history_index > 0) {
    var steps = 1;
    for (var i = 1; i <= steps; i++) {
      json.history_index += -1;
      var statement = json.history[json.history_index].redo.split("=");
      if (statement[0] == "json.students" || statement[0] == "json.assignments" || statement[0] == "json") {
        eval(statement[0]+"="+eval(unescape(statement[1])));
      } else if (/__m__/.test(statement[0])) { //multiple statements changed at once and recorded in one redo step. Indiv. statements separated by __m__
        statement[0] = statement[0].split("__m__");
        statement[1] = statement[1].split("__m__");
        for (i=0; i < statement[0].length; i++)
          eval(statement[0][i]+"="+eval(unescape(statement[1][i])));
      } else {
        eval(statement[0]+"="+unescape(statement[1]));
      }
    }
    importData();
    if (json.history_index == 0) el("redo_button").disabled = true;
    el("undo_button").disabled = false;
  }
}




function revert()
{
  importData(backup);
  save();
  el("undo_button").disabled = true;
  el("redo_button").disabled = false;
}

function unrevert()
{
  importData(backup);
  save();
  el("redo_button").disabled = true;
  el("undo_button").disabled = false;
}
